package be.iminds.ilabt.jfed.experiment;

import be.iminds.ilabt.jfed.highlevel.jobs.JobFactory;
import be.iminds.ilabt.jfed.highlevel.util.SliceRegistryUtil;
import be.iminds.ilabt.jfed.lowlevel.user.GeniUserProvider;
import be.iminds.ilabt.jfed.lowlevel.testbed_info.TestbedInfoSource;
import be.iminds.ilabt.jfed.preferences.JFedCorePreferences;

import javax.inject.Inject;
import javax.inject.Singleton;

/**
 * User: twalcari
 * Date: 2/5/2015
 * Time: 11:09
 */
@Singleton
public class ExperimentControllerFactoryImpl implements ExperimentControllerFactory {
    private final JobFactory jobFactory;
    private final TestbedInfoSource testbedInfoSource;
    private final JFedCorePreferences jFedPreferences;
    private final GeniUserProvider geniUserProvider;
    private final SliceRegistryUtil sliceRegistryUtil;

    @Inject
    public ExperimentControllerFactoryImpl(JobFactory jobFactory,
                                           TestbedInfoSource testbedInfoSource,
                                           JFedCorePreferences jFedPreferences,
                                           GeniUserProvider geniUserProvider,
                                           SliceRegistryUtil sliceRegistryUtil) {
        this.jobFactory = jobFactory;
        this.testbedInfoSource = testbedInfoSource;
        this.jFedPreferences = jFedPreferences;
        this.geniUserProvider = geniUserProvider;
        this.sliceRegistryUtil = sliceRegistryUtil;
    }

    @Override
    public ExperimentController createExperimentController(Experiment experiment){
        return new ExperimentControllerImpl(experiment,
                jobFactory, testbedInfoSource, jFedPreferences, geniUserProvider, sliceRegistryUtil);
    }
}
